part of modern_form_core;

extension ModernFormDateTimeExtension on DateTimeRange? {
  String get toElegantString {
    String text = "";

    if (this != null) {
      text += ModernFormUtils.dateFormat.format(this!.start);
      if (this!.end != DateTime(0, 0, 0)) {
        text += " - ";
        text += ModernFormUtils.dateFormat.format(this!.end);
      }
    }

    return text;
  }

  Map<String, dynamic> toMap() {
    return {
      'start': this?.start.millisecondsSinceEpoch,
      'end': this?.end.millisecondsSinceEpoch,
    };
  }

  static DateTimeRange? fromMap(Map<String, dynamic>? map) {
    if (map == null) {
      return null;
    }

    return DateTimeRange(
      start: map['start'] != null
          ? DateTime.fromMillisecondsSinceEpoch(map['start'])
          : DateTime(0, 0, 0),
      end: map['end'] != null
          ? DateTime.fromMillisecondsSinceEpoch(map['end'])
          : DateTime(0, 0, 0),
    );
  }
}
