part of modern_form_core;

extension ModernFormListExtension on List? {
  List<E> customAddAll<E>(List<E> value) {
    List<E> _itens = List<E>.from(this ?? []);
    _itens.addAll(value);
    return _itens;
  }

  void removeAll<E>(List<E> value) {
    for (var item in value) {
      this?.remove(item);
    }
  }

  List<E> customRemoveAll<E>(List<E> value) {
    List<E> _itens = List<E>.from(this ?? []);
    _itens.removeAll(value);

    return _itens;
  }

  void customForEach<E>(void f(E? element, int index)) {
    for (var i = 0; i < (this?.length ?? 0); i++) {
      E? e = this?[i];
      f(e, i);
    }
  }

  bool get isNotNullAndNotEmpty {
    return this != null && this!.isNotEmpty;
  }
}

extension CList on List {
  E? customFirst<E>() {
    try {
      E? iten;

      if (this.isNotEmpty) {
        iten = this.first;
      }

      return iten;
    } catch (e) {
      return null;
    }
  }

  E? customLast<E>() {
    try {
      E? iten;

      if (this.isNotEmpty) {
        iten = this.last;
      }

      return iten;
    } catch (e) {
      return null;
    }
  }
}
