import 'dart:typed_data';
import 'package:http/http.dart' as http;
import 'package:modern_form/modern_form_core.dart';

class ModernFormDownloadPlatformHelper {
  static Future<Uint8List?> downloadWithProgress(
    String url, {
    void Function(int, int)? onBytesReceived,
    Duration? timeLimit,
  }) async {
    return simpleDownload(url);
  }

  static Future<Uint8List?> simpleDownload(String url) async {
    Uint8List? bytes;

    try {
      http.Response response = await http.get(Uri.parse(url));

      bytes = response.bodyBytes;
    } on http.ClientException catch (e) {
      print("ERROR --> $e");
      print("ERROR Type ${e.runtimeType}");

      if (e.toString() == "XMLHttpRequest error.") {
        dialog(
          titleText: "Erro",
          contentText: "Habilite o CORS em seu servidor de imagens!!",
          okButtonText: "OK",
        );
      }
    }

    return bytes;
  }
}
