part of modern_form_core;

final _keyScaff = GlobalKey<ScaffoldState>();

class ModernFormGlobalContext {
  static BuildContext Function()? customContext;

  static BuildContext? get context =>
      customContext != null ? customContext!() : _keyScaff.currentContext;

  static Size get size => MediaQuery.of(context!).size;
  static double get width => size.width;
  static double get height => size.height;

  static Widget builder(BuildContext c, Widget child) {
    return Navigator(
      initialRoute: '/',
      onGenerateRoute: (_) => MaterialPageRoute(
        builder: (c) => _BuildPage(
          child: child,
        ),
      ),
    );
  }
}

class _BuildPage extends StatefulWidget {
  final Widget? child;
  const _BuildPage({Key? key, this.child}) : super(key: key);
  @override
  __BuildPageState createState() => __BuildPageState();
}

class __BuildPageState extends State<_BuildPage> {
  @override
  Widget build(BuildContext c) {
    return Scaffold(
      resizeToAvoidBottomInset: false,
      key: _keyScaff,
      body: widget.child,
    );
  }
}
