part of modern_form_core;

class ModernFormExpansionCardWithEdit extends StatelessWidget {
  final String? label;
  final String? subTitle;
  final Color? subTitleColor;
  final Widget? child;
  final void Function(bool)? onTapOpen;
  final CrossAxisAlignment? crossAxisAlignment;
  final void Function(BuildContext context)? onTapEdit;

  const ModernFormExpansionCardWithEdit({
    Key? key,
    this.label,
    this.subTitle,
    this.subTitleColor,
    this.onTapOpen,
    this.crossAxisAlignment,
    this.child,
    this.onTapEdit,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return ModernFormExpansionCard(
      label: label,
      subTitle: subTitle,
      subTitleColor: subTitleColor,
      onTapOpen: onTapOpen,
      crossAxisAlignment: crossAxisAlignment,
      child: child,
      headerChild: Padding(
        padding: EdgeInsets.only(right: ScreenUtil().setWidth(20)),
        child: Builder(
          builder: (context) {
            return InkWell(
              child: Padding(
                padding: EdgeInsets.all(ScreenUtil().setSp(5)),
                child: Icon(
                  Icons.edit,
                  size: ScreenUtil().setSp(20),
                  color: Colors.white,
                ),
              ),
              onTap: () {
                if (onTapEdit != null) {
                  onTapEdit!(context);
                }
              },
            );
          },
        ),
      ),
    );
  }
}
