import 'dart:io';
import 'package:flutter/material.dart';
import 'package:modern_form/src/core/widgets/images/ImageWidget/network/CustomNetWorkImage_mobile.dart';
import 'package:rxdart/rxdart.dart';
import 'NetWorkImageDefault.dart';

BehaviorSubject<ImageProvider<Object>> imageProviderWidgetNetwork(
    String imageUrl,
    {bool? forceNetworkIfNotMemory}) {
  // ignore: close_sinks
  BehaviorSubject<ImageProvider<Object>> stream =
      BehaviorSubject<ImageProvider<Object>>();
  stream.add(imageProviderWidgetNetworkDefault(imageUrl));

  if (forceNetworkIfNotMemory == null || !forceNetworkIfNotMemory) {
    Future<void> task() async {
      final controller = CustomNetWorkImageController(imageUrl);
      await controller.init();
      File file = controller.file;
      bool isFile = file.path != "";
      if (isFile) {
        stream.add(FileImage(file));
      }
    }

    task();
  }

  return stream;
}
