part of modern_form_core;

class ModernFormDatePicker extends StatelessWidget {
  final void Function(DateTime)? onChanged;
  final String? label;
  final String? helperText;
  final DateTime? value;
  final bool? dateAndTime;
  final bool? enabled;
  final String? Function(dynamic)? validator;

  const ModernFormDatePicker({
    Key? key,
    this.onChanged,
    this.label,
    this.value,
    this.dateAndTime = true,
    this.enabled = true,
    this.validator,
    this.helperText,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    String valueText = "";
    if (value != null) {
      valueText = ModernFormUtils.dateTimeFormat(value);
      if (dateAndTime != null && !dateAndTime!) {
        valueText = ModernFormUtils.dateFormat.format(value!);
      }
    }

    return ModernFormFakeTextField(
      label: label ?? "Data",
      helperText: helperText,
      validator: validator,
      initialValue: valueText,
      sufixIconEnabled: false,
      enabled: enabled,
      onTap: () async {
        DateTime? newDate = await showModernFormDateTimePicker(
          initialDate: value ?? DateTime.now(),
          dateAndTime: dateAndTime,
        );
        if (newDate != null && onChanged != null) {
          onChanged!(newDate);
        }
      },
    );
  }
}
