part of modern_form_core;

class ModernFormMultiTextPicker<T> extends StatelessWidget {
  final String? label;
  final String? helperText;
  final String? buttonLabel;

  final bool? forceMenu;
  final bool? moveEnable;

  final List<ModernFormBottomSheetModel<T>> suggestions;
  final List<ModernFormBottomSheetModel<T>>? value;
  final void Function(List<T>)? onChanged;

  final String? Function(List<T>?)? validator;

  const ModernFormMultiTextPicker({
    Key? key,
    this.label,
    required this.suggestions,
    this.forceMenu,
    this.onChanged,
    this.value,
    this.buttonLabel,
    this.validator,
    this.helperText,
    this.moveEnable,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    List<T>? _value = value?.map((e) => e.value).toList();

    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        Text(label ?? "", style: ModernFormTextStyle.moderFormLabelStyle),
        helperText != null
            ? Padding(
                padding: EdgeInsets.only(top: ScreenUtil().setHeight(5)),
                child: Text(helperText!,
                    style: ModernFormTextStyle.moderFormHelperStyle),
              )
            : SizedBox(),
        validator != null && validator!(_value) != null
            ? Text(
                validator!(_value)!,
                style: ModernFormTextStyle.moderFormErrorStyle,
              )
            : SizedBox(),
        ModernFormFilterWithCheckboxIten(
          bottomSheetLabelText: "Selecione",
          buttonText: buttonLabel ?? "Adicionar",
          forceMenu: forceMenu,
          moveEnable: moveEnable,
          suggestions: suggestions,
          value: value,
          onChanged: onChanged,
        ),
      ],
    );
  }
}
