part of modern_form_core;

class ModernFormProgressIndicator extends StatelessWidget {
  final Color? color;
  final double? value;

  const ModernFormProgressIndicator(
      {Key? key, this.color = Colors.blue, this.value})
      : super(key: key);
  @override
  Widget build(BuildContext context) {
    return Center(
      child: LayoutBuilder(
        builder: (context, constraints) {
          if (Theme.of(context).platform == TargetPlatform.iOS) {
            return Column(
              mainAxisAlignment: MainAxisAlignment.center,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: <Widget>[CupertinoActivityIndicator()],
            );
          } else {
            double? v = value;
            if (v != null && (v.isInfinite || v.isNaN)) {
              v = 0;
            }
            return Column(
              mainAxisAlignment: MainAxisAlignment.center,
              crossAxisAlignment: CrossAxisAlignment.center,
              children: <Widget>[
                CircularProgressIndicator(
                  strokeWidth: 1,
                  value: v,
                  valueColor: AlwaysStoppedAnimation<Color?>(color),
                ),
              ],
            );
          }
        },
      ),
    );
  }
}
