import 'dart:async';
import 'dart:convert';
// ignore: avoid_web_libraries_in_flutter
import 'dart:js' as js;
import 'dart:typed_data';
import 'package:file_picker/file_picker.dart';
import 'package:modern_form/modern_form_core.dart';

class ModernFormFilePlatformHelper {
  static Future<Uint8List?> getFile(ModernFormFileExtensionType type) async {
    FilePickerResult? result = await FilePicker.platform.pickFiles(
      type: FileType.custom,
      allowedExtensions: [type.toValueString],
    );

    return result?.files.single.bytes ?? null;
  }

  static Future<void> openFileWithPath(String path) async {}

  static Future<void> openFileWithBytes(
      List<int> bytes, String name, String type) async {
    String _type = "application/";

    if (type == "pdf") {
      _type += "pdf";
    } else if (type == "xls" || type == "xlsx") {
      _type += "vnd.openxmlformats-officedocument.spreadsheetml.sheet";
    }

    js.context['pdfdata'] = base64.encode(bytes);
    js.context['filename'] = name;

    Timer.run(() {
      js.context.callMethod('download', [_type]);
    });
  }

  static Future<String> getFilePathFromUrl(
      String url, String fileExtension) async {
    return "";
  }

  static Future<String> getApplicationDocumentsDirectory() async {
    return "";
  }
}
