part of modern_form_files;

class ModernFormViewFile extends StatelessWidget {
  final Uint8List? file;
  final String? fileUrl;
  final String? fileName;
  final ModernFormFileExtensionType? fileExtensionType;

  const ModernFormViewFile({
    Key? key,
    required this.file,
    required this.fileUrl,
    required this.fileName,
    required this.fileExtensionType,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return InkWell(
      onTap: () {
        if (file != null && file!.isNotEmpty) {
          ModernFormFileHelper.openFileWithBytes(
            file!.toList(),
            fileName,
            fileExtensionType.toValueString,
          );
        } else {
          if (fileUrl != null) {
            launch(fileUrl!);
          }
        }
      },
      child: Padding(
        padding: const EdgeInsets.all(8.0),
        child: Text("Ver arquivo $fileName"),
      ),
    );
  }
}
