part of modern_form_images;

class ModernFormMultiImagePicker extends StatelessWidget {
  final String? label;
  final String? helperText;
  final bool? enabled;
  final List<Uint8List>? images;
  final void Function(List<Uint8List>)? onChanged;
  final void Function(String url)? onChangePaste;
  final String? Function(List<Uint8List>?)? validator;
  final bool? labelEnabled;
  final bool? pasteEnabled;

  const ModernFormMultiImagePicker({
    Key? key,
    this.images,
    this.label,
    this.onChanged,
    this.enabled,
    this.validator,
    this.labelEnabled,
    this.onChangePaste,
    this.pasteEnabled,
    this.helperText,
  }) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return Column(
      crossAxisAlignment: CrossAxisAlignment.start,
      children: [
        labelEnabled == null || labelEnabled!
            ? Text(label ?? "Múltiplas imagens",
                style: ModernFormTextStyle.moderFormLabelStyle)
            : Container(),
        helperText != null
            ? Padding(
                padding: EdgeInsets.only(top: ScreenUtil().setHeight(5)),
                child: Text(helperText ?? "",
                    style: ModernFormTextStyle.moderFormHelperStyle),
              )
            : SizedBox(),
        validator != null && validator!(images) != null
            ? Text(validator!(images) ?? "",
                style: ModernFormTextStyle.moderFormErrorStyle)
            : Container(),
        SizedBox(height: ScreenUtil().setHeight(2)),
        Padding(
          padding: EdgeInsets.symmetric(vertical: ScreenUtil().setHeight(5)),
          child: Container(
            height: ScreenUtil().setWidth(90),
            child: ListView(
              scrollDirection: Axis.horizontal,
              children: [
                SizedBox(width: ScreenUtil().setWidth(5)),
                ModernFormViewImages(
                  imagesMemory: images,
                  onDelete: (index) {
                    List<Uint8List> _i = List<Uint8List>.from(images!);
                    _i.removeAt(index);
                    onChanged!(_i);
                  },
                ),
                SizedBox(
                    width: ScreenUtil().setWidth(
                        images != null && images!.isNotEmpty ? 20 : 0)),
                ModernFormUpload(
                  onTap: (enabled ?? true)
                      ? () async {
                          List<Uint8List> _i =
                              List<Uint8List>.from(images ?? []);
                          List<Uint8List> bytes =
                              await ModernFormImageHelper.getImages();

                          _i.addAll(bytes.where((element) => true));

                          onChanged!(_i);
                        }
                      : null,
                  pasteEnabled: pasteEnabled,
                  onChange: (enabled ?? true) ? onChangePaste : null,
                ),
                SizedBox(width: ScreenUtil().setWidth(5)),
              ],
            ),
          ),
        ),
      ],
    );
  }
}
