part of modern_form_videos;

class ModernFormViewVideo extends StatefulWidget {
  final String? videoUrl;
  final String? videoPath;
  final bool? shareArquiveEnabled;

  const ModernFormViewVideo({
    Key? key,
    this.videoUrl,
    this.videoPath,
    this.shareArquiveEnabled,
  }) : super(key: key);

  @override
  _ModernFormViewVideoState createState() => _ModernFormViewVideoState();
}

class _ModernFormViewVideoState extends State<ModernFormViewVideo> {
  void Function(BuildContext)? share;
  bool isError = false;

  FlickManager? flickManager;
  Widget? child;

  @override
  void initState() {
    share =
        _share(widget.videoUrl, widget.videoPath, widget.shareArquiveEnabled);

    flickManager = ModernFormViewVideoHelper.flickManager(
      widget.videoUrl,
      widget.videoPath,
      onError,
    );

    super.initState();
  }

  @override
  Widget build(BuildContext context) {
    bool isYoutube = widget.videoPath == null &&
        widget.videoUrl != null &&
        (widget.videoUrl!.contains('youtube') ||
            widget.videoUrl!.contains('youtu.be'));

    if (isYoutube) {
      child = ModernFormYoutubeViewPlayer(url: widget.videoUrl, share: share);
    } else if (!isError) {
      child = ModernFormVideoPlayer(flickManager: flickManager, share: share);
    }

    return child ?? SizedBox();
  }

  void onError() {
    child = Row(
      mainAxisAlignment: MainAxisAlignment.spaceEvenly,
      children: [
        ElevatedButton(
          child: Text(
            "Fazer download",
            style: TextStyle(color: Colors.white),
          ),
          style: ElevatedButton.styleFrom(
            primary: ModernFormUtils.primaryColor,
          ),
          onPressed: () async {
            await ModernFormViewVideoHelper.downloadArquive(widget.videoUrl!);
            setState(() {
              flickManager = ModernFormViewVideoHelper.flickManager(
                widget.videoUrl,
                widget.videoPath,
                onError,
              );
            });
            showFlushBar(value: true, textTrue: "Atualize a página!!");
          },
        ),
        ElevatedButton(
          child: Text(
            "Abrir vídeo",
            style: TextStyle(color: Colors.white),
          ),
          style: ElevatedButton.styleFrom(
            primary: ModernFormUtils.secundaryColor,
          ),
          onPressed: () {
            launch(widget.videoUrl!);
          },
        ),
      ],
    );
    if (!isError) {
      setState(() {
        isError = true;
      });
    }
  }
}

void Function(BuildContext) _share(
    String? url, String? path, bool? shareArquiveEnabled) {
  return (BuildContext context) {
    ModernFormLinksHelper.showShareType(
      context,
      onShareUrl: () async {
        ModernFormViewVideoHelper.shareUrl(url);
      },
      onShareArquive: shareArquiveEnabled == false
          ? null
          : () async {
              ModernFormViewVideoHelper.shareArquive(path!, url);
            },
      onDelete: () async {
        dialogDelete(
          () async {
            await ModernFormViewVideoHelper.deleteArquive(path!);
            showFlushBar(value: true, textTrue: "Atualize a página!!");
          },
          "arquivo",
        );
      },
      menuLocation: ModernFormPopupMenuLocation.BottomRight,
    );
  };
}
